//------------------------------------------------------------------------+ 
// Function to evaluate the adjustment of an individual. Called from UGA. |
// The optimized function of the task is calculated in it.                |
//------------------------------------------------------------------------+
//========Skin============================================================
//(-5..5)
//MIN(3.07021;3.315935)= -4.3182 one point
//MAX(-3.315699;-3.072485)= 14.0606 one point 
void FitnessFunction(int chromos)
{
  double x1 =0.0;
  double x2 =0.0;
  double sum=0.0;
  int    cnt=1;

  while (cnt<=GeneCount)
  {
    x1=Colony[cnt][chromos];
    cnt++;
    x2=Colony[cnt][chromos];
    cnt++;
    sum+=pow(cos((double) (2 * x1 * x1)) - 0.11e1, 0.2e1) + 
         pow(sin(0.5e0 * (double) x1) - 0.12e1, 0.2e1) - 
         pow(cos((double) (2 * x2 * x2)) - 0.11e1, 0.2e1) + 
         pow(sin(0.5e0 * (double) x2) - 0.12e1, 0.2e1);
  }
  AmountStartsFF++;
  Colony[0][chromos]=sum;
}
//

//-----------------------------------------------------------------------+
// Service function. Called from UGA.                                    |
// If there is no need in it, leave the function empty as following:     |
//   void ServiceFunction()                                              |
//   {                                                                   |
//   }                                                                   |
//-----------------------------------------------------------------------+
void ServiceFunction()
{
  double x1 =0.0;
  double x2 =0.0;
  int    cnt=1;
  ERROR=0.0;

  if (OptimizeMethod==1)
  {
    while (cnt<=GeneCount)
    {
      x1=Chromosome[cnt];
      ERROR+=MathAbs(3.0702-x1);
      cnt++;
      x2=Chromosome[cnt];
      ERROR+=MathAbs(3.3159-x2);
      cnt++;
    }
    ERROR=ERROR/GeneCount;
    Comment("Fitness func =",Chromosome[0],"\n",
            "Standard values of arguments:","\n",
            "x1 = 3.0702","\n",
            "x2 = 3.3159","\n",
            "Obtained values of arguments:","\n",
            "x1 =",Chromosome[1],"\n",
            "x2 =",Chromosome[2],"\n",
            " ","\n",
            "Average error per gene=",ERROR);
  }
  else
  {
    while (cnt<=GeneCount)
    {
      x1=Chromosome[cnt];
      ERROR+=MathAbs(-3.3157-x1);
      cnt++;
      x2=Chromosome[cnt];
      ERROR+=MathAbs(-3.0725-x2);
      cnt++;
    }
    ERROR=ERROR/GeneCount;
    Comment("Fitness func =",Chromosome[0],"\n",
            "Standard values of arguments:","\n",
            "x1 = -3.3157","\n",
            "x2 = -3.0725","\n",
            "Obtained values of arguments:","\n",
            "x1 =",Chromosome[1],"\n",
            "x2 =",Chromosome[2],"\n",
            " ","\n",
            "Average error per gene=",ERROR);
  }
}
//
